/*-----------------------------------------------------------*/
/*	  LCDo̓eXgvO								 */
/*-----------------------------------------------------------*/
/*	̃\[X͈ȉ̂̂CĎgpB
	http://akiba.geocities.jp/atmel_avr_atros/img/attiny/2313lcd.lzh
	Ce:
		|[gԍ̊ɍ킹ĕύXB
		F_CPU`폜B
		lcd_waitoOCB
		vg^Cv錾wb_ɈړB
		lcd_position4sΉɕύXB
		lcd_clear()ǉB
*/
#include <avr/io.h>
#include <util/delay.h>
#include "lcddriver.h"

#define LCD_PORT   PORTD /*|[g*/
#define LCD_PORTO  DDRD  /*|[gݒ*/

#define LCD_E  (1 << 4)  /* rbg ENABLE	   */
#define LCD_RS (1 << 6)  /* rbg REGISTER SELECT	*/

#define LCD_DATS	4	 /* f[^oX̃rbgVtg*/
#define LCD_DATMASK 0xf  /* f[^oX̃}XN*/


/*-----------------------------------------------------------*/

/*-----------------------------------------------------------*/

void lcd_wait( int m )
{
	while(m--)
	{
		_delay_ms(1);
	}
	//_delay_ms(m);	//ƃ\[XɐH
}

/*-----------------------------------------------------------*/
/*	  LCD 											 */
/*-----------------------------------------------------------*/
void lcd_init(void)
{
	LCD_PORTO =0xff;

	LCD_PORT &= ~LCD_RS;	/* RS = L */
	lcd_put_4bit( 0x3 );	/*Function Set Mode */
	lcd_wait(5);

	lcd_put_4bit( 0x3 );
	
	lcd_wait(5);
	lcd_put_4bit( 0x3 );
	lcd_put_4bit( 0x2 );	/*Function Set Mode=4bit */

	lcd_put_ch( 0x28 );		/* Mode=4bit / Line=2 / Font=5x7dot*/
	lcd_put_ch( 0x0C );		/* Display=ON / Cursor=OFF / Blink=OFF */
	lcd_put_ch( 0x06 );		/* Cursor=Increment / Display_shift=OFF */
	lcd_put_ch( 0x01 );		/* Display Clear*/

	lcd_wait(2);
	LCD_PORT |= LCD_RS;		/* RS = H */
}

/*-----------------------------------------------------------*/
/*	  LCD\ʒu̐ݒ 									 */
/* Fchar tx   :xW									 */
/* Fchar ty   :yW									 */
/* ߂lFȂ 											 */
/*				tx											 */
/*		0123456789ABCDEF									 */
/*	ty 0################									 */
/*	   1################									 */
/*-----------------------------------------------------------*/
void lcd_position(char tx ,char ty)
{
	switch(ty)
	{
		case 0:
			ty = 0x00;
			break;
		case 1:
			ty = 0x40;
			break;
		case 2:
			ty = 0x14;
			break;
		case 3:
			ty = 0x54;
			break;
	}
	LCD_PORT &= ~LCD_RS;					/* RS = L */
	lcd_put_ch(0x80 | (tx + ty));	/* Address = 0 */
	LCD_PORT |= LCD_RS;						/* RS = H */
}

/*-----------------------------------------------------------*/
/*		  LCD 4rbgM									 */
/* F char bitdata : DB7-4ɗ^f[^				 */
/*-----------------------------------------------------------*/
void lcd_put_4bit(char bitdata)
{
	LCD_PORT &= ~LCD_DATMASK;
	LCD_PORT |= LCD_DATMASK & bitdata;		/*f[^i[ */
	LCD_PORT ^= LCD_E;						/* ENABLE = L*/
	_delay_us(100);

	LCD_PORT ^= LCD_E;						/* ENABLE = H */
	_delay_us(100);
}

/*-----------------------------------------------------------*/
/*		  LCD@1oCgM									 */
/* F  char ch : LCDW[ւ̑Mf[^			 */
/*-----------------------------------------------------------*/
void lcd_put_ch(char ch)
{
	lcd_put_4bit(ch >> 4);					/* 4rbgM */
	lcd_put_4bit(LCD_DATMASK & ch);			/* 4rbgM */

	_delay_us(100);
}

/*-----------------------------------------------------------*/
/*		  LCD \									 */
/* F char *str : ̐擪|C^					 */
/*-----------------------------------------------------------*/
void lcd_put_str(char *str)
{
	while(*str != 0) {
		lcd_put_ch( *str );
		str++;
	}
}

//lcd̕\
void lcd_clear(void)
{
	LCD_PORT &= ~LCD_RS;					/* RS = L */
	lcd_put_ch(0b00000001);	//R}h
	LCD_PORT |= LCD_RS;						/* RS = H */
}
